
#ifndef __DECSS_H__
#define __DECSS_H__

#include <stdio.h>

typedef unsigned char CSS_Key[5];			// 40-bit value, MSB is first elem.
typedef unsigned char CSS_Challenge[10];	// 80-bit value, MSB is first elem.

////////////////////////////////////////////////////////////////////////////////////////////////

class DeCSS
{
public:
	DeCSS();
	~DeCSS();
	int open(char* FileName);
	int read(void *buf,int NumBytes);
	int eof();
	int tell();
	int seek(int pos);
	int close();
	virtual int AuthorizeDrive(char *FileName);
	virtual int GetStreamKey(char *FileName,CSS_Key *StreamKey);
	virtual int IsCiphered();

protected:
	FILE			*fil;
	unsigned char	SectorBuf[2048];
	int				SectorOfs,SectorSize,PosInFile;
	CSS_Key			StreamKey;
	void CryptKey1(int Varient,const CSS_Challenge Challenge,CSS_Key *Key1);
	void CryptKey2(int Varient,const CSS_Challenge Challenge,CSS_Key *Key2);
	void CryptBusKey(int Varient,const CSS_Key Key1,CSS_Key Key2,CSS_Key *BusKey);
	void RemoveCSS(CSS_Key Key,unsigned char *sec);

private:
	int FlagIsCiphered;
	void _generate_bits(unsigned char *output,int len,const unsigned char *s);
	void DeCSS::mangle1(unsigned char *bs,unsigned char cse, const unsigned char *ip,unsigned char *op);
	void DeCSS::mangle2(unsigned char *bs,unsigned char cse, const unsigned char *ip,unsigned char *op);
	void engine(int varient,const unsigned char *input,unsigned char *output);
};

#endif